=== test/app/CMakeLists.txt ===
build_module(loaderslib loaderslib.c)
