=== debian/changelog ===
tarantool (1.9.1.26.g63eb81e3c-1.1build3) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 03 Mar 2020 21:42:20 +0100

tarantool (1.9.1.26.g63eb81e3c-1.1build2) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 13 Feb 2020 09:45:45 +0100

tarantool (1.9.1.26.g63eb81e3c-1.1build1) disco; urgency=medium

  * No-change rebuild for readline soname change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 14 Jan 2019 20:04:38 +0000

tarantool (1.9.1.26.g63eb81e3c-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add upstream fix for FTBFS with curl >= 7.62. (Closes: #913380)

 -- Adrian Bunk <bunk@debian.org>  Fri, 30 Nov 2018 12:45:36 +0200

tarantool (1.9.1.26.g63eb81e3c-1) unstable; urgency=medium

  * New upstream version.
   + Don't install systemd service file twice, closes: #881481.

 -- Dmitry E. Oboukhov <unera@debian.org>  Fri, 08 Jun 2018 23:03:14 +0300
